import 'dart:convert';
import './entity-contract.dart';
import './vote-contract.dart';
import '../net/gateway.dart';

/// Call a method on the given contract instance using the given Gateway URI
/// by passing the given parameters
Future<List<dynamic>> callEntityMethod(String gatewayUri,
    String contractAddress, String method, List<dynamic> params) async {
  Web3Gateway gw = Web3Gateway(gatewayUri);

  return gw.callMethod(
      jsonEncode(entityResolverAbi), contractAddress, method, params);
}

/// Call a method on the given contract instance using the given Gateway URI
/// by passing the given parameters
Future<List<dynamic>> callVoteMethod(String gatewayUri, String contractAddress,
    String method, List<dynamic> params) async {
  Web3Gateway gw = Web3Gateway(gatewayUri);

  return gw.callMethod(
      jsonEncode(votingProcessAbi), contractAddress, method, params);
}
